Bug 1285412 - Review Request: nodejs-ebnf-parser - A parser for BNF and EBNF grammars used by jison
Review Request: nodejs-ebnf-parser - A parser for BNF and EBNF grammars used ...
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Tom Hughes
Fedora Extras Quality Assurance
:
Depends On:
Blocks: nodejs-reviews 1296302
  Show dependency treegraph
 
Reported: 2015-11-25 09:44 EST by Jared Smith
Modified: 2016-01-11 15:21 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-01-11 15:21:20 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
tom: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Jared Smith 2015-11-25 09:44:20 EST
Spec URL: https://jsmith.fedorapeople.org/Packaging/nodejs-ebnf-parser/nodejs-ebnf-parser.spec
SRPM URL: https://jsmith.fedorapeople.org/Packaging/nodejs-ebnf-parser/nodejs-ebnf-parser-0.1.10-1.fc24.src.rpm
Description: A parser for BNF and EBNF grammars used by jison
Fedora Account System Username: jsmith
Comment 1 Tom Hughes 2015-11-25 13:51:51 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "*No copyright* MIT/X11 (BSD like)", "Unknown or generated". 15
     files have unknown license. Detailed output of licensecheck in
     /home/tom/1285412-nodejs-ebnf-parser/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[!]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[-]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: nodejs-ebnf-parser-0.1.10-1.fc24.noarch.rpm
          nodejs-ebnf-parser-0.1.10-1.fc24.src.rpm
nodejs-ebnf-parser.noarch: W: spelling-error Summary(en_US) jison -> bison
nodejs-ebnf-parser.noarch: W: spelling-error %description -l en_US jison -> bison
nodejs-ebnf-parser.noarch: W: only-non-binary-in-usr-lib
nodejs-ebnf-parser.src: W: spelling-error Summary(en_US) jison -> bison
nodejs-ebnf-parser.src: W: spelling-error %description -l en_US jison -> bison
2 packages and 0 specfiles checked; 0 errors, 5 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
nodejs-ebnf-parser.noarch: W: only-non-binary-in-usr-lib
1 packages and 0 specfiles checked; 0 errors, 1 warnings.



Requires
--------
nodejs-ebnf-parser (rpmlib, GLIBC filtered):
    nodejs
    nodejs(engine)



Provides
--------
nodejs-ebnf-parser:
    nodejs-ebnf-parser
    npm(ebnf-parser)



Source checksums
----------------
https://registry.npmjs.org/ebnf-parser/-/ebnf-parser-0.1.10.tgz :
  CHECKSUM(SHA256) this package     : cf3efec74297ed0fddcfb1a7b906c11a449b8acbc97d97d03cc7a395564ab885
  CHECKSUM(SHA256) upstream package : cf3efec74297ed0fddcfb1a7b906c11a449b8acbc97d97d03cc7a395564ab885


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -m compton-rawhide-x86_64 -b 1285412
Buildroot used: compton-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 2 Tom Hughes 2015-11-25 13:54:32 EST
Needs BRs on npm(lex-parser) and npm(test) when tests are enables.

Also it does have a run time dependency on lex-parser that is not declared in the package.json because ebnf-parser.js requires it. It will work when used as part of jison because node will search up the tree and find lex-parser but it wouldn't work if used on it's own.

So I think we should convert the devDependency on lex-parser to a normal one with something like:

%nodejs_fixdep --dev -r lex-parser
%nodejs_fixdep lex-parser 0.1.0
Comment 3 Piotr Popieluch 2015-11-25 14:23:49 EST
Please check the logic around the BuildRequires, I think the check on the test needs to be removed. Now you can't build the package when the tests are disabled.
Comment 4 Piotr Popieluch 2015-11-27 06:10:34 EST
npm-test is now in rawhide and has buildroot overrides. Tests can be enabled.
Comment 5 Piotr Popieluch 2016-01-07 15:30:53 EST
Ok, to keep thing going I've updated the spec. 

Tom, are you ok to review my changes?

Spec URL: https://piotrp.fedorapeople.org/nodejs-ebnf-parser.spec
SRPM URL: https://piotrp.fedorapeople.org/nodejs-ebnf-parser-0.1.10-1.fc23.src.rpm
Comment 6 Tom Hughes 2016-01-07 16:29:46 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "*No copyright* MIT/X11 (BSD like)", "Unknown or generated". 15
     files have unknown license. Detailed output of licensecheck in
     /home/tom/1285412-nodejs-ebnf-parser/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[-]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: nodejs-ebnf-parser-0.1.10-1.fc24.noarch.rpm
          nodejs-ebnf-parser-0.1.10-1.fc24.src.rpm
nodejs-ebnf-parser.noarch: W: spelling-error Summary(en_US) jison -> bison
nodejs-ebnf-parser.noarch: W: spelling-error %description -l en_US jison -> bison
nodejs-ebnf-parser.noarch: W: only-non-binary-in-usr-lib
nodejs-ebnf-parser.noarch: W: dangling-symlink /usr/lib/node_modules/ebnf-parser/node_modules/lex-parser /usr/lib/node_modules/lex-parser
nodejs-ebnf-parser.src: W: spelling-error Summary(en_US) jison -> bison
nodejs-ebnf-parser.src: W: spelling-error %description -l en_US jison -> bison
2 packages and 0 specfiles checked; 0 errors, 6 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
nodejs-ebnf-parser.noarch: W: spelling-error Summary(en_US) jison -> bison
nodejs-ebnf-parser.noarch: W: spelling-error %description -l en_US jison -> bison
nodejs-ebnf-parser.noarch: W: only-non-binary-in-usr-lib
nodejs-ebnf-parser.noarch: W: dangling-symlink /usr/lib/node_modules/ebnf-parser/node_modules/lex-parser /usr/lib/node_modules/lex-parser
1 packages and 0 specfiles checked; 0 errors, 4 warnings.



Requires
--------
nodejs-ebnf-parser (rpmlib, GLIBC filtered):
    nodejs
    nodejs(engine)
    npm(lex-parser)



Provides
--------
nodejs-ebnf-parser:
    nodejs-ebnf-parser
    npm(ebnf-parser)



Source checksums
----------------
https://registry.npmjs.org/ebnf-parser/-/ebnf-parser-0.1.10.tgz :
  CHECKSUM(SHA256) this package     : cf3efec74297ed0fddcfb1a7b906c11a449b8acbc97d97d03cc7a395564ab885
  CHECKSUM(SHA256) upstream package : cf3efec74297ed0fddcfb1a7b906c11a449b8acbc97d97d03cc7a395564ab885


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -m compton-rawhide-x86_64 -b 1285412
Buildroot used: compton-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 7 Tom Hughes 2016-01-07 16:31:32 EST
Yes that looks fine. Jared, are you happy to use that spec?
Comment 8 Jared Smith 2016-01-09 16:53:09 EST
Yes, I just returned from vacation, and I'd be happy to use the updated spec provided by Piotr during my absence.
Comment 9 Tom Hughes 2016-01-09 19:03:45 EST
Great. On that basis package is approved.
Comment 10 Gwyn Ciesla 2016-01-11 14:49:46 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/nodejs-ebnf-parser

Note You need to log in before you can comment on or make changes to this bug.